{$A+,B-,E-,F-,N-,O-,V-,I- }

{$IFDEF DEBUG }
  {$D+,L+,R+,S+ }
{$ELSE }
  {$D-,L-,R-,S- }
{$ENDIF }

Unit VdtTools;

interface

const
     RIEN        = 250;
     CarGraphik  = 240;
(*
function  GraphCorrector( val : byte) : byte;
procedure TradDataMntl ( car : char; var dest : string );
*)
implementation

function GraphCorrector( val : byte) : byte;
(* on sous entend que la valeur est obligatoirement superieur ou egal a 32 *)
(* car c'est ainsi que l'information est place en memoire *)
begin
  val := (val and 127) or 32;
  if val = 127 then val := 95;
  GraphCorrector := val;
end;

const
      TabInf32  : array[24..27] of char = ('-','/','.',','); { les flches }

      TabSup128 : array[128..255,1..2] of char = (
{  128} (#75,'C'),(#72,'u'),(#66,'e'),(#67,'a'),(#72,'a'),(#65,'a'), {  }
{  134} (#00,#00),(#75,'c'),(#67,'e'),(#72,'e'),(#65,'e'),(#72,'i'), {  }
{  140} (#67,'i'),(#00,'i'),(#00,'A'),(#67,'A'),(#66,'E'),('z',#00), {  }
{  146} ('j',#00),(#67,'o'),(#72,'o'),(#00,'o'),(#67,'u'),(#65,'u'), {  }
{  152} (#00,'y'),(#00,'O'),(#00,'U'),(#00,#00),('#',#00),(#00,#00), {  }
{  158} (#00,#00),(#00,#00),(#00,'a'),(#00,'i'),(#00,'o'),(#00,'u'), {  }
{  164} (#00,'n'),(#00,'N'),(#00,#00),(#00,#00),(#00,#00),(#00,#00), {  }
{  170} (#00,#00),('=',#00),('<',#00),(#00,#00),(#00,#00),(#00,#00), {  }
{  176} (#0,#127),(#0,#127),(#0,#127),(#00,'|'),(#00,#00),(#00,#00), {  }
{  182} (#00,#00),(#00,#00),(#00,#00),(#00,#00),(#00,'|'),(#00,#00), {  }
{  188} (#00,#00),(#00,#00),(#00,#00),(#00,#00),(#00,#00),(#00,#00), {  }
{  194} (#00,#00),(#00,#00),(#00,'`'),(#00,#00),(#00,#00),(#00,#00), {  }
{  200} (#00,#00),(#00,#00),(#00,#00),(#00,#00),(#00,#00),(#00,'`'), {  }
{  206} (#00,#00),(#00,#00),(#00,#00),(#00,#00),(#00,#00),(#00,#00), {  }
{  212} (#00,#00),(#00,#00),(#00,#00),(#00,#00),(#00,#00),(#00,#00), {  }
{  218} (#00,#00),(#0,#127),(#00,'_'),(#00,'{'),(#00,'}'),(#00,'~'), {  }
{  224} (#00,#00),('{',#00),(#00,#00),(#00,#00),(#00,#00),(#00,#00), {  }
{  230} (#00,#00),(#00,#00),(#00,#00),(#00,#00),(#00,#00),(#00,#00), {  }
{  236} (#00,#00),('>',#00),(#00,#00),(#00,#00),(#00,#00),('1',#00), {  }
{  242} (#00,#00),(#00,#00),(#00,#00),(#00,#00),(#56,#00),(#00,#00), {  }
{  248} ('0',#00),(#00,#00),(#00,#00),(#00,#00),(#00,#00),(#00,#00), {  }
{  254} (#00,#00),(#00,#00) { $FF }
        );

procedure IbmVdt( var sour, dest : string );
var read  : word;
    write : word;
    c     : char;
    c2    : char;
begin
  read := 1;
  write := 0;
  while (read<=length(sour)) do
    begin
      c := sour[read];
      if c<' ' then
        begin
          if (c>=#24) and (c<=#27) then
            begin
              inc(write);
              dest[write] := #25;
              inc(write);
              dest[write] := TabInf32[byte(c)];
            end
          else
            if c=#21 then
              begin
                inc(write);
                dest[write] := #25;
                inc(write);
                dest[write] := #39;
              end;
        end
      else
        if c<#128 then
          begin
            inc(write);
            dest[write] := c;
          end
        else
          begin
            c2 := TabSup128[byte(c),1];
            if c2>#00 then
              begin
                inc(write);
                dest[write] := #25;
                inc(write);
                dest[write] := c2;
              end;
            c2 := TabSup128[byte(c),2];
            if c2>#00 then
              begin
                inc(write);
                dest[write] := c2;
              end;
          end;
      inc(read);
    end;
  dest[0] := char(write);
end;

procedure TradDataMntl ( car : char; var dest : string );
var s : string[1];
begin
  s[1] := car;
  s[0] := #01;
  IbmVdt(s,dest);
end;

end.
